var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Messaging_native, _Messaging_app, _Messaging_delegate, _Messaging_onMessage, _Messaging_onToken, _Messaging_onNotificationTap;
import { Application, ApplicationSettings, Device } from '@nativescript/core';
import { deserialize, firebase, FirebaseApp, FirebaseError } from '@nativescript/firebase-core';
import { AuthorizationStatus } from './common';
export { AuthorizationStatus } from './common';
let _registerDeviceForRemoteMessages = {
    resolve: null,
    reject: null,
};
let defaultMessaging;
const fb = firebase();
Object.defineProperty(fb, 'messaging', {
    value: () => {
        if (!defaultMessaging) {
            defaultMessaging = new Messaging();
        }
        return defaultMessaging;
    },
    writable: false,
});
const REMOTE_NOTIFICATIONS_REGISTRATION_STATUS = 'org.nativescript.firebase.notifications.status';
export class Messaging {
    constructor() {
        _Messaging_native.set(this, void 0);
        _Messaging_app.set(this, void 0);
        _Messaging_delegate.set(this, void 0);
        _Messaging_onMessage.set(this, void 0);
        _Messaging_onToken.set(this, void 0);
        _Messaging_onNotificationTap.set(this, void 0);
        if (defaultMessaging) {
            return defaultMessaging;
        }
        defaultMessaging = this;
        if (!Application.ios.delegate) {
            Application.ios.delegate = AppDelegateImpl;
        }
        AppDelegateImpl.sharedInstance.observe();
        __classPrivateFieldSet(this, _Messaging_native, FIRMessaging.messaging(), "f");
        __classPrivateFieldSet(this, _Messaging_delegate, FIRMessagingDelegateImpl.initWithOwner(new WeakRef(this)), "f");
        __classPrivateFieldGet(this, _Messaging_native, "f").delegate = __classPrivateFieldGet(this, _Messaging_delegate, "f");
        Application.ios.addNotificationObserver(UIApplicationDidFinishLaunchingNotification, (notification) => {
            var _a, _b, _c;
            UNUserNotificationCenterDelegateImpl.sharedInstance.observe();
            const auto = (_a = ApplicationSettings.getBoolean(REMOTE_NOTIFICATIONS_REGISTRATION_STATUS)) !== null && _a !== void 0 ? _a : false;
            const isSimulator = UIDevice.currentDevice.name.toLocaleLowerCase().indexOf('simulator');
            if (auto && !isSimulator) {
                (_c = (_b = UIApplication === null || UIApplication === void 0 ? void 0 : UIApplication.sharedApplication) === null || _b === void 0 ? void 0 : _b.registerForRemoteNotifications) === null || _c === void 0 ? void 0 : _c.call(_b);
            }
        });
    }
    get _onMessage() {
        return __classPrivateFieldGet(this, _Messaging_onMessage, "f");
    }
    get _onNotificationTap() {
        return __classPrivateFieldGet(this, _Messaging_onNotificationTap, "f");
    }
    get _onToken() {
        return __classPrivateFieldGet(this, _Messaging_onToken, "f");
    }
    getToken() {
        return new Promise((resolve, reject) => {
            var _a;
            if (!UIDevice.currentDevice.name.toLocaleLowerCase().indexOf('simulator') && !UIApplication.sharedApplication.registeredForRemoteNotifications) {
                reject(new Error('You must be registered for remote messages before calling getToken, see messaging().registerDeviceForRemoteMessages()'));
            }
            (_a = this.native) === null || _a === void 0 ? void 0 : _a.tokenWithCompletion((token, error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve(token);
                }
            });
        });
    }
    getAPNSToken() {
        return TNSFirebaseMessaging.APNSTokenToString(this.native.APNSToken);
    }
    _hasPermission(resolve, reject) {
        if (parseInt(Device.osVersion) >= 10) {
            UNUserNotificationCenter.currentNotificationCenter().getNotificationSettingsWithCompletionHandler((settings) => {
                let status = AuthorizationStatus.NOT_DETERMINED;
                switch (settings.authorizationStatus) {
                    case 2 /* Authorized */:
                        status = AuthorizationStatus.AUTHORIZED;
                        break;
                    case 1 /* Denied */:
                        status = AuthorizationStatus.DENIED;
                        break;
                    case 4 /* Ephemeral */:
                        status = AuthorizationStatus.EPHEMERAL;
                        break;
                    case 3 /* Provisional */:
                        status = AuthorizationStatus.PROVISIONAL;
                        break;
                    case 0 /* NotDetermined */:
                        status = AuthorizationStatus.NOT_DETERMINED;
                        break;
                }
                resolve(status);
            });
        }
        else {
            resolve(AuthorizationStatus.AUTHORIZED);
        }
    }
    hasPermission() {
        return new Promise((resolve, reject) => {
            this._hasPermission(resolve, reject);
        });
    }
    onMessage(listener) {
        __classPrivateFieldSet(this, _Messaging_onMessage, listener, "f");
    }
    onToken(listener) {
        __classPrivateFieldSet(this, _Messaging_onToken, listener, "f");
    }
    onNotificationTap(listener) {
        __classPrivateFieldSet(this, _Messaging_onNotificationTap, listener, "f");
    }
    registerDeviceForRemoteMessages() {
        return new Promise((resolve, reject) => {
            var _a, _b;
            if (UIDevice.currentDevice.name.toLocaleLowerCase().indexOf('simulator')) {
                ApplicationSettings.setBoolean(REMOTE_NOTIFICATIONS_REGISTRATION_STATUS, true);
                resolve();
            }
            _registerDeviceForRemoteMessages.resolve = resolve;
            _registerDeviceForRemoteMessages.reject = reject;
            if (UIApplication === null || UIApplication === void 0 ? void 0 : UIApplication.sharedApplication) {
                (_b = (_a = UIApplication === null || UIApplication === void 0 ? void 0 : UIApplication.sharedApplication) === null || _a === void 0 ? void 0 : _a.registerForRemoteNotifications) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            else {
                const cb = (args) => {
                    var _a, _b;
                    (_b = (_a = UIApplication === null || UIApplication === void 0 ? void 0 : UIApplication.sharedApplication) === null || _a === void 0 ? void 0 : _a.registerForRemoteNotifications) === null || _b === void 0 ? void 0 : _b.call(_a);
                    Application.off('launch', cb);
                };
                Application.on('launch', cb);
            }
        });
    }
    requestPermission(permissions) {
        return new Promise((resolve, reject) => {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
            const version = parseInt(Device.osVersion);
            if (version >= 10) {
                let options = UNAuthorizationOptionNone;
                if ((_b = (_a = permissions === null || permissions === void 0 ? void 0 : permissions.ios) === null || _a === void 0 ? void 0 : _a.alert) !== null && _b !== void 0 ? _b : true) {
                    options = options | 4 /* Alert */;
                }
                if ((_d = (_c = permissions === null || permissions === void 0 ? void 0 : permissions.ios) === null || _c === void 0 ? void 0 : _c.badge) !== null && _d !== void 0 ? _d : true) {
                    options = options | 1 /* Badge */;
                }
                if ((_f = (_e = permissions === null || permissions === void 0 ? void 0 : permissions.ios) === null || _e === void 0 ? void 0 : _e.sound) !== null && _f !== void 0 ? _f : true) {
                    options = options | 2 /* Sound */;
                }
                if ((_h = (_g = permissions === null || permissions === void 0 ? void 0 : permissions.ios) === null || _g === void 0 ? void 0 : _g.carPlay) !== null && _h !== void 0 ? _h : true) {
                    options = options | 8 /* CarPlay */;
                }
                if (version >= 12) {
                    if ((_j = permissions === null || permissions === void 0 ? void 0 : permissions.ios) === null || _j === void 0 ? void 0 : _j.criticalAlert) {
                        options = options | 16 /* CriticalAlert */;
                    }
                    if ((_k = permissions === null || permissions === void 0 ? void 0 : permissions.ios) === null || _k === void 0 ? void 0 : _k.provisional) {
                        options = options | 64 /* Provisional */;
                    }
                }
                if (version >= 13 && version <= 15) {
                    options = options | 128 /* Announcement */;
                }
                UNUserNotificationCenter.currentNotificationCenter().requestAuthorizationWithOptionsCompletionHandler(options, (result, error) => {
                    if (error) {
                        reject(FirebaseError.fromNative(error));
                    }
                    else {
                        this._hasPermission(resolve, reject);
                    }
                });
            }
            else {
                const notificationTypes = 2 /* Sound */ | 4 /* Alert */ | 1 /* Badge */;
                const settings = UIUserNotificationSettings.settingsForTypesCategories(notificationTypes, null);
                UIApplication.sharedApplication.registerUserNotificationSettings(settings);
                this._hasPermission(resolve, reject);
            }
        });
    }
    subscribeToTopic(topic) {
        return new Promise((resolve, reject) => {
            this.native.subscribeToTopicCompletion(topic, (error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve();
                }
            });
        });
    }
    unregisterDeviceForRemoteMessages() {
        return new Promise((resolve, reject) => {
            try {
                UIApplication.sharedApplication.unregisterForRemoteNotifications();
                ApplicationSettings.setBoolean(REMOTE_NOTIFICATIONS_REGISTRATION_STATUS, false);
                resolve();
            }
            catch (e) {
                reject(e);
            }
        });
    }
    unsubscribeFromTopic(topic) {
        return new Promise((resolve, reject) => {
            this.native.unsubscribeFromTopicCompletion(topic, (error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve();
                }
            });
        });
    }
    deleteToken() {
        return new Promise((resolve, reject) => {
            var _a;
            (_a = this.native) === null || _a === void 0 ? void 0 : _a.deleteDataWithCompletion((error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve();
                }
            });
        });
    }
    get isDeviceRegisteredForRemoteMessages() {
        return UIApplication.sharedApplication.registeredForRemoteNotifications;
    }
    get autoInitEnabled() {
        var _a;
        return (_a = this.native) === null || _a === void 0 ? void 0 : _a.autoInitEnabled;
    }
    set autoInitEnabled(value) {
        this.native.autoInitEnabled = value;
    }
    get app() {
        if (!__classPrivateFieldGet(this, _Messaging_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _Messaging_app, FirebaseApp.fromNative(FIRApp.defaultApp()), "f");
        }
        return __classPrivateFieldGet(this, _Messaging_app, "f");
    }
    get native() {
        return __classPrivateFieldGet(this, _Messaging_native, "f");
    }
    get ios() {
        return this.native;
    }
}
_Messaging_native = new WeakMap(), _Messaging_app = new WeakMap(), _Messaging_delegate = new WeakMap(), _Messaging_onMessage = new WeakMap(), _Messaging_onToken = new WeakMap(), _Messaging_onNotificationTap = new WeakMap();
var FIRMessagingDelegateImpl = /** @class */ (function (_super) {
    __extends(FIRMessagingDelegateImpl, _super);
    function FIRMessagingDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FIRMessagingDelegateImpl_1 = FIRMessagingDelegateImpl;
    FIRMessagingDelegateImpl.initWithOwner = function (owner) {
        var delegate = FIRMessagingDelegateImpl_1.new();
        delegate._owner = owner;
        return delegate;
    };
    FIRMessagingDelegateImpl.prototype.messagingDidReceiveRegistrationToken = function (_messaging, fcmToken) {
        var _a;
        if (!fcmToken) {
            return;
        }
        (_a = defaultMessaging === null || defaultMessaging === void 0 ? void 0 : defaultMessaging._onToken) === null || _a === void 0 ? void 0 : _a.call(defaultMessaging, fcmToken);
        var selector = 'messaging:didReceiveRegistrationToken:';
        if (GULAppDelegateSwizzler.sharedApplication().delegate.respondsToSelector(selector)) {
            // @ts-ignore
            GULAppDelegateSwizzler.sharedApplication().delegate.messagingDidReceiveRegistrationToken(_messaging.APNSToken, fcmToken);
        }
    };
    var FIRMessagingDelegateImpl_1;
    FIRMessagingDelegateImpl = FIRMessagingDelegateImpl_1 = __decorate([
        ObjCClass(FIRMessagingDelegate)
    ], FIRMessagingDelegateImpl);
    return FIRMessagingDelegateImpl;
}(NSObject));
let notificationCenterDelegate;
let notificationCenterDelegateObserving = false;
let originalNotificationCenterDelegate;
const originalDelegateRespondsTo = {
    willPresentNotification: true,
    didReceiveNotificationResponse: true,
    openSettingsForNotification: true,
};
var UNUserNotificationCenterDelegateImpl = /** @class */ (function (_super) {
    __extends(UNUserNotificationCenterDelegateImpl, _super);
    function UNUserNotificationCenterDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UNUserNotificationCenterDelegateImpl_1 = UNUserNotificationCenterDelegateImpl;
    Object.defineProperty(UNUserNotificationCenterDelegateImpl, "sharedInstance", {
        get: function () {
            if (!notificationCenterDelegate) {
                notificationCenterDelegate = UNUserNotificationCenterDelegateImpl_1.new();
            }
            return notificationCenterDelegate;
        },
        enumerable: true,
        configurable: true
    });
    UNUserNotificationCenterDelegateImpl.prototype.observe = function () {
        if (!notificationCenterDelegateObserving) {
            var center = UNUserNotificationCenter.currentNotificationCenter();
            if (center.delegate) {
                originalNotificationCenterDelegate = center.delegate;
                originalDelegateRespondsTo.openSettingsForNotification = originalNotificationCenterDelegate.respondsToSelector('userNotificationCenter:openSettingsForNotification:');
                originalDelegateRespondsTo.willPresentNotification = originalNotificationCenterDelegate.respondsToSelector('userNotificationCenter:willPresentNotification:withCompletionHandler:');
                originalDelegateRespondsTo.didReceiveNotificationResponse = originalNotificationCenterDelegate.respondsToSelector('userNotificationCenter:didReceiveNotificationResponse:withCompletionHandler:');
            }
            center.delegate = UNUserNotificationCenterDelegateImpl_1.sharedInstance;
            notificationCenterDelegateObserving = true;
        }
    };
    UNUserNotificationCenterDelegateImpl.prototype.userNotificationCenterDidReceiveNotificationResponseWithCompletionHandler = function (center, response, completionHandler) {
        var _a;
        var remoteNotification = response.notification.request.content.userInfo;
        if (remoteNotification.objectForKey('gcm.message_id')) {
            var message = parseNotification(response.notification);
            if (message) {
                message['foreground'] = UIApplication.sharedApplication.applicationState === UIApplicationState.Active;
            }
            (_a = defaultMessaging === null || defaultMessaging === void 0 ? void 0 : defaultMessaging._onNotificationTap) === null || _a === void 0 ? void 0 : _a.call(defaultMessaging, message);
        }
        if (originalNotificationCenterDelegate && originalDelegateRespondsTo.didReceiveNotificationResponse) {
            originalNotificationCenterDelegate.userNotificationCenterDidReceiveNotificationResponseWithCompletionHandler(center, response, completionHandler);
        }
        else {
            completionHandler();
        }
    };
    UNUserNotificationCenterDelegateImpl.prototype.userNotificationCenterOpenSettingsForNotification = function (center, notification) {
        if (originalNotificationCenterDelegate && originalDelegateRespondsTo.openSettingsForNotification) {
            originalNotificationCenterDelegate.userNotificationCenterOpenSettingsForNotification(center, notification);
        }
    };
    UNUserNotificationCenterDelegateImpl.prototype.userNotificationCenterWillPresentNotificationWithCompletionHandler = function (center, notification, completionHandler) {
        var _a;
        var options = UNNotificationPresentationOptionNone;
        var aps = notification.request.content.userInfo.objectForKey('aps');
        if ((defaultMessaging === null || defaultMessaging === void 0 ? void 0 : defaultMessaging.showNotificationsWhenInForeground) || notification.request.content.userInfo.objectForKey('gcm.notification.showWhenInForeground') === 'true' || notification.request.content.userInfo.objectForKey('showWhenInForeground') === true || (aps && aps.objectForKey('showWhenInForeground') === true)) {
            options = UNNotificationPresentationOptions.Alert | UNNotificationPresentationOptions.Sound | UNNotificationPresentationOptions.Badge;
        }
        if (notification.request.content.userInfo.objectForKey('gcm.message_id')) {
            var message = parseNotification(notification);
            if (!message['contentAvailable']) {
                (_a = defaultMessaging === null || defaultMessaging === void 0 ? void 0 : defaultMessaging._onMessage) === null || _a === void 0 ? void 0 : _a.call(defaultMessaging, message);
                if (message) {
                    message['foreground'] = UIApplication.sharedApplication.applicationState === UIApplicationState.Active;
                }
            }
            completionHandler(options);
        }
        if (originalNotificationCenterDelegate && originalDelegateRespondsTo.willPresentNotification) {
            originalNotificationCenterDelegate.userNotificationCenterWillPresentNotificationWithCompletionHandler(center, notification, completionHandler);
        }
        else {
            completionHandler(options);
        }
    };
    var UNUserNotificationCenterDelegateImpl_1;
    UNUserNotificationCenterDelegateImpl = UNUserNotificationCenterDelegateImpl_1 = __decorate([
        ObjCClass(UNUserNotificationCenterDelegate)
    ], UNUserNotificationCenterDelegateImpl);
    return UNUserNotificationCenterDelegateImpl;
}(NSObject));
function parseNotification(notification) {
    var _a, _b;
    return parseRemoteMessage((_b = (_a = notification === null || notification === void 0 ? void 0 : notification.request) === null || _a === void 0 ? void 0 : _a.content) === null || _b === void 0 ? void 0 : _b.userInfo);
}
function parseRemoteMessage(remoteMessage) {
    var _a, _b;
    const message = {};
    const data = {};
    const notification = {};
    const notificationIOS = {};
    const keys = remoteMessage.allKeys;
    const count = keys.count;
    for (let i = 0; i < count; i++) {
        const key = keys.objectAtIndex(i);
        if (key === 'gcm.message_id' || key === 'google.message_id' || key === 'message_id') {
            message['messageId'] = remoteMessage.objectForKey(key);
            continue;
        }
        // message.messageType
        if (key === 'message_type') {
            message['messageType'] = remoteMessage.objectForKey(key);
            continue;
        }
        // message.collapseKey
        if (key === 'collapse_key') {
            message['collapseKey'] = remoteMessage.objectForKey(key);
            continue;
        }
        // message.from
        if (key === 'from') {
            message['from'] = remoteMessage.objectForKey(key);
            continue;
        }
        // message.sentTime
        if ([key === 'google.c.a.ts']) {
            message['sentTime'] = remoteMessage.objectForKey(key);
            continue;
        }
        // message.to
        if ([key === 'to'] || [key === 'google.to']) {
            message['to'] = remoteMessage.objectForKey(key);
            continue;
        }
        // build data dict from remaining keys but skip keys that shouldn't be included in data
        if (key === 'aps' || key.startsWith('gcm.') || key.startsWith('google.')) {
            continue;
        }
        // message.apple.imageUrl
        if (key === 'fcm_options') {
            const imageUrl = (_b = (_a = remoteMessage.objectForKey(key)) === null || _a === void 0 ? void 0 : _a.objectForKey) === null || _b === void 0 ? void 0 : _b.call(_a, 'image');
            if (imageUrl) {
                notificationIOS['imageUrl'] = (imageUrl === null || imageUrl === void 0 ? void 0 : imageUrl.absoluteString) || imageUrl;
            }
            continue;
        }
        data[key] = deserialize(remoteMessage.objectForKey(key));
    }
    message['data'] = data;
    const apsDict = remoteMessage.objectForKey('aps');
    if (apsDict) {
        // message.category
        const category = apsDict.objectForKey('category');
        if (category) {
            message['category'] = category;
        }
        // message.threadId
        const threadId = apsDict.objectForKey('thread-id');
        if (threadId) {
            message['threadId'] = threadId;
        }
        // message.contentAvailable
        const contentAvailable = apsDict.objectForKey('content-available');
        if (contentAvailable) {
            message['contentAvailable'] = contentAvailable;
        }
        // message.mutableContent
        const mutableContent = apsDict.objectForKey('mutable-content');
        if (mutableContent) {
            message['mutableContent'] = true;
        }
        // message.notification.*
        const alert = apsDict.objectForKey('alert');
        if (alert) {
            // can be a string or dictionary
            if (typeof alert === 'string') {
                // message.notification.title
                notification['title'] = alert;
            }
            else if (alert instanceof NSDictionary) {
                const apsAlertDict = alert;
                // message.notification.title
                const title = apsAlertDict.objectForKey('title');
                if (title) {
                    notification['title'] = title;
                }
                // message.notification.titleLocKey
                const titleLocKey = apsAlertDict.objectForKey('title-loc-key');
                if (titleLocKey) {
                    notification['titleLocKey'] = titleLocKey;
                }
                // message.notification.titleLocArgs
                const titleLocArgs = apsAlertDict.objectForKey('title-loc-args');
                if (titleLocArgs) {
                    notification['titleLocArgs'] = deserialize(titleLocArgs);
                }
                // message.notification.body
                const body = apsAlertDict.objectForKey('body');
                if (body) {
                    notification['body'] = body;
                }
                // message.notification.bodyLocKey
                const bodyLocKey = apsAlertDict.objectForKey('loc-key');
                if (bodyLocKey) {
                    notification['bodyLocKey'] = bodyLocKey;
                }
                // message.notification.bodyLocArgs
                const bodyLocArgs = apsAlertDict.objectForKey('loc-args');
                if (bodyLocArgs) {
                    notification['bodyLocArgs'] = deserialize(bodyLocArgs);
                }
                // Apple only
                // message.notification.apple.subtitle
                const subtitle = apsAlertDict.objectForKey('subtitle');
                if (subtitle) {
                    notificationIOS['subtitle'] = subtitle;
                }
                // Apple only
                // message.notification.apple.subtitleLocKey
                const subtitleLocKey = apsAlertDict.objectForKey('subtitle-loc-key');
                if (subtitleLocKey) {
                    notificationIOS['subtitleLocKey'] = subtitleLocKey;
                }
                // Apple only
                // message.notification.apple.subtitleLocArgs
                const subtitleLocArgs = apsAlertDict.objectForKey('subtitle-loc-args');
                if (subtitleLocArgs) {
                    notificationIOS['subtitleLocArgs'] = deserialize(subtitleLocArgs);
                }
                // Apple only
                // message.notification.apple.badge
                const badge = apsAlertDict.objectForKey('badge');
                if (badge) {
                    notificationIOS['badge'] = badge;
                }
            }
            notification['apple'] = notificationIOS;
            message['notification'] = notification;
        }
        // message.notification.apple.sound
        const sound = apsDict.objectForKey('sound');
        if (sound) {
            if (typeof sound === 'string') {
                // message.notification.apple.sound
                notification['sound'] = {
                    name: sound,
                    critical: false,
                    volume: 1,
                };
            }
            else if (sound instanceof NSDictionary) {
                const apsSoundDict = sound;
                const notificationIOSSound = {};
                // message.notification.apple.sound.name String
                const name = apsSoundDict.objectForKey('name');
                if (name) {
                    notificationIOSSound['name'] = name;
                }
                // message.notification.apple.sound.critical Boolean
                const critical = apsSoundDict.objectForKey('critical');
                if (critical) {
                    notificationIOSSound['critical'] = Boolean(critical);
                }
                // message.notification.apple.sound.volume Number
                const volume = apsSoundDict.objectForKey('volume');
                if (volume !== null) {
                    notificationIOSSound['volume'] = volume;
                }
                // message.notification.apple.sound
                notificationIOS['sound'] = notificationIOSSound;
            }
        }
        notification['apple'] = notificationIOS;
        message['notification'] = notification;
    }
    return message;
}
let appDelegate;
let appDelegateInit = false;
var AppDelegateImpl = /** @class */ (function (_super) {
    __extends(AppDelegateImpl, _super);
    function AppDelegateImpl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AppDelegateImpl_1 = AppDelegateImpl;
    Object.defineProperty(AppDelegateImpl, "sharedInstance", {
        get: function () {
            if (!appDelegate) {
                appDelegate = AppDelegateImpl_1.alloc().init();
            }
            return appDelegate;
        },
        enumerable: true,
        configurable: true
    });
    AppDelegateImpl.prototype.observe = function () {
        if (!appDelegateInit) {
            GULAppDelegateSwizzler.registerAppDelegateInterceptor(appDelegate);
            GULAppDelegateSwizzler.proxyOriginalDelegateIncludingAPNSMethods();
            appDelegateInit = true;
        }
    };
    AppDelegateImpl.prototype.applicationDidFailToRegisterForRemoteNotificationsWithError = function (application, error) {
        var _a;
        (_a = _registerDeviceForRemoteMessages === null || _registerDeviceForRemoteMessages === void 0 ? void 0 : _registerDeviceForRemoteMessages.reject) === null || _a === void 0 ? void 0 : _a.call(_registerDeviceForRemoteMessages, error);
        _registerDeviceForRemoteMessages.resolve = null;
        _registerDeviceForRemoteMessages.reject = null;
    };
    AppDelegateImpl.prototype.applicationDidRegisterForRemoteNotificationsWithDeviceToken = function (application, deviceToken) {
        var _a;
        FIRMessaging.messaging().APNSToken = deviceToken;
        ApplicationSettings.setBoolean(REMOTE_NOTIFICATIONS_REGISTRATION_STATUS, true);
        (_a = _registerDeviceForRemoteMessages === null || _registerDeviceForRemoteMessages === void 0 ? void 0 : _registerDeviceForRemoteMessages.resolve) === null || _a === void 0 ? void 0 : _a.call(_registerDeviceForRemoteMessages, UIApplication.sharedApplication.registeredForRemoteNotifications);
        _registerDeviceForRemoteMessages.resolve = null;
        _registerDeviceForRemoteMessages.reject = null;
    };
    AppDelegateImpl.prototype.applicationDidReceiveRemoteNotificationFetchCompletionHandler = function (application, userInfo, completionHandler) {
        var _a;
        var message = parseRemoteMessage(userInfo);
        if (message) {
            message['foreground'] = application.applicationState === UIApplicationState.Active;
        }
        (_a = defaultMessaging === null || defaultMessaging === void 0 ? void 0 : defaultMessaging._onMessage) === null || _a === void 0 ? void 0 : _a.call(defaultMessaging, message);
        completionHandler(UIBackgroundFetchResult.NewData);
    };
    AppDelegateImpl.prototype.applicationDidRegisterUserNotificationSettings = function (application, notificationSettings) {
        var _a;
        (_a = _registerDeviceForRemoteMessages === null || _registerDeviceForRemoteMessages === void 0 ? void 0 : _registerDeviceForRemoteMessages.resolve) === null || _a === void 0 ? void 0 : _a.call(_registerDeviceForRemoteMessages, UIApplication.sharedApplication.registeredForRemoteNotifications);
        _registerDeviceForRemoteMessages.resolve = null;
        _registerDeviceForRemoteMessages.reject = null;
    };
    var AppDelegateImpl_1;
    AppDelegateImpl = AppDelegateImpl_1 = __decorate([
        ObjCClass(UIApplicationDelegate)
    ], AppDelegateImpl);
    return AppDelegateImpl;
}(UIResponder));
//# sourceMappingURL=index.ios.js.map